diff --git a/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java b/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
index 247f66636..45e614f14 100644
--- a/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.Minecraft;
 import java.util.Random;
 
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
@@ -8,6 +9,7 @@ import org.lwjgl.opengl.GL11;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.client.render.RenderBlocks;
+import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.tessalator.TessellatorStandard;
@@ -25,7 +27,7 @@ import static org.lwjgl.opengl.GL11.glPushMatrix;
 
 public class ItemEntityRenderer extends EntityRenderer<EntityItem>
 {
-	private final RenderBlocks renderBlocks;
+	public final RenderBlocks renderBlocks;
 	private final Random random;
 	public boolean useColor;
 
@@ -46,6 +48,8 @@ public class ItemEntityRenderer extends EntityRenderer<EntityItem>
 	}
 
 	public void doRender(Tessellator tessellator, final EntityItem entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+		final Minecraft mc = Minecraft.getMinecraft(this);
+		float brightness = entity.getBrightness(partialTick);
 		random.setSeed(187L);
 		final ItemStack itemstack = entity.item;
 		if(itemstack == null) {
@@ -56,8 +60,8 @@ public class ItemEntityRenderer extends EntityRenderer<EntityItem>
 			return;
 		}
 		glPushMatrix();
-		final float bobbingOffset = MathHelper.sin((entity.age + partialTick) / 10F + entity.field_804_d) * 0.1F + 0.1F;
-		final float f3 = (float) Math.toDegrees(((entity.age + partialTick) / 20F + entity.field_804_d));
+		final float bobbingOffset = MathHelper.sin((entity.age + partialTick) / 10F + entity.initialRotation) * 0.1F + 0.1F;
+		final float f3 = (float) Math.toDegrees(((entity.age + partialTick) / 20F + entity.initialRotation));
 		byte renderCount = 1;
 		if (entity.item.stackSize > 1) {
 			renderCount = 2;
@@ -70,7 +74,8 @@ public class ItemEntityRenderer extends EntityRenderer<EntityItem>
 		}
 		GL11.glTranslatef((float) x, (float) y + bobbingOffset, (float) z);
 		GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
-		ItemModelDispatcher.getInstance().getDispatch(item).renderAsItemEntity(TessellatorStandard.instance, entity, renderBlocks, random, itemstack, renderCount, f3, partialTick);
+		BlockModel.setRenderBlocks(renderBlocks);
+		ItemModelDispatcher.getInstance().getDispatch(item).renderAsItemEntity(TessellatorStandard.instance, entity, random, itemstack, renderCount, f3, brightness, partialTick);
 		GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
 		GL11.glPopMatrix();
 	}
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index a136b6bd8..e73add089 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -1,17 +1,17 @@
 package net.minecraft.client.render.item.model;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -22,9 +22,11 @@ public abstract class ItemModel {
     }
     public abstract void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, EntityPlayer player, ItemStack stack, float partialTick);
     public void renderItem(Tessellator tessellator, ItemRenderer renderer, EntityLiving entityLiving, ItemStack itemStack){
-        renderItem(tessellator, renderer, entityLiving, itemStack, true);
+        final Minecraft mc = Minecraft.getMinecraft(this);
+        float brightness = entityLiving.getBrightness(1.0f);
+        renderItem(tessellator, renderer, itemStack, entityLiving, brightness, true);
     }
-    public abstract void renderItem(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform);
+    public abstract void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, @Nullable Entity entity, float brightness, boolean handheldTransform);
     public abstract void renderItemThirdPerson(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform);
     public void renderItemIntoGui(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemstack, int x, int y, float alpha) {
         renderItemIntoGui(tessellator, fontrenderer, renderengine, itemstack, x, y, 1.0f, alpha);
@@ -35,6 +37,7 @@ public abstract class ItemModel {
     }
 
     public abstract void renderItemOverlayIntoGUI(Tessellator tessellator, FontRenderer fontrenderer, RenderEngine renderengine, ItemStack itemstack, int x, int y, String override, float alpha);
-    public abstract void renderAsItemEntity(Tessellator tessellator, EntityItem entity, RenderBlocks renderBlocks, Random random, ItemStack itemstack, int renderCount, float yaw, float partialTick);
-    public abstract IconCoordinate getIcon(Entity entity, ItemStack itemStack);
+    public abstract void renderAsItemEntity(Tessellator tessellator, @Nullable Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick);
+    public abstract void renderItemInWorld(Tessellator tessellator, Entity entity, ItemStack itemStack, float brightness, float alpha, boolean worldTransform);
+    public abstract IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack);
 }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index e05cca6d1..772fbd1e0 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -3,7 +3,6 @@ package net.minecraft.client.render.item.model;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.RenderEngine;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
@@ -12,12 +11,12 @@ import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.ItemBlock;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 import java.util.Random;
@@ -35,6 +34,10 @@ public class ItemModelBlock extends ItemModelStandard {
     }
     @Override
     public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, EntityPlayer player, ItemStack stack, float partialTick) {
+        final Minecraft mc = Minecraft.getMinecraft(this);
+        float brightness = player.getBrightness(1.0f);
+        if (mc.fullbright || itemfullBright) brightness = 1.0f;
+
         final float distanceScale = 0.8F; // Relates to how close the held item renders from the camera
         final float swingProgress = player.getSwingProgress(partialTick);
         final float animationProgress2 = MathHelper.sin(swingProgress * MathHelper.PI);
@@ -57,22 +60,19 @@ public class ItemModelBlock extends ItemModelStandard {
         {
             GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
         }
-        renderItem(tessellator, renderer,player, stack, true);
+        renderItem(tessellator, renderer, stack, player, brightness, true);
     }
     @Override
-    public void renderItem(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform) {
+    public void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, @Nullable Entity entity, float brightness, boolean handheldTransform) {
         if(BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).shouldItemRender3d())
         {
-            Minecraft mc = Minecraft.getMinecraft(this);
             GL11.glEnable(GL_BLEND);
             GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
             TextureRegistry.blockAtlas.bindTexture();
-            float brightness = entity.getBrightness(1.0f);
-            if (mc.fullbright || itemfullBright) brightness = 1.0f;
             BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness);
             GL11.glDisable(GL_BLEND);
         } else {
-            super.renderItem(tessellator, renderer, entity, itemstack, handheldTransform);
+            super.renderItem(tessellator, renderer, itemstack, entity, brightness, handheldTransform);
         }
     }
     @Override
@@ -124,11 +124,10 @@ public class ItemModelBlock extends ItemModelStandard {
         GL11.glDisable(GL_BLEND);
     }
     @Override
-    public void renderAsItemEntity(Tessellator tessellator, EntityItem entity, RenderBlocks renderBlocks, Random random, ItemStack itemstack, int renderCount, float yaw, float partialTick) {
+    public void renderAsItemEntity(Tessellator tessellator, @Nullable Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick) {
         if (Block.blocksList[itemstack.itemID] != null && BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).shouldItemRender3d()) {
             GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
             TextureRegistry.blockAtlas.bindTexture();
-            BlockModel.setRenderBlocks(renderBlocks);
             final float itemSize = blockModel.getItemRenderScale();
             GL11.glScalef(itemSize, itemSize, itemSize);
             for (int i = 0; i < renderCount; i++) {
@@ -139,14 +138,41 @@ public class ItemModelBlock extends ItemModelStandard {
                     final float rOffZ = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / itemSize;
                     GL11.glTranslatef(rOffX, rOffY, rOffZ);
                 }
-                float brightness = entity.getBrightness(partialTick);
                 if (Minecraft.getMinecraft(this).fullbright || itemfullBright) brightness = 1.0f;
                 blockModel.renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness);
                 GL11.glPopMatrix();
             }
         } else {
-            super.renderAsItemEntity(tessellator, entity, renderBlocks, random, itemstack, renderCount, yaw, partialTick);
+            super.renderAsItemEntity(tessellator, entity, random, itemstack, renderCount, yaw, brightness, partialTick);
+        }
+    }
+    @Override
+    public void renderItemInWorld(Tessellator tessellator, Entity entity, ItemStack itemStack, float brightness, float alpha, boolean worldTransform) {
+        if (itemStack == null) return;
+        GL11.glEnable(GL_BLEND);
+        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+        GL11.glEnable(GL_CULL_FACE);
+        if (BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).shouldItemRender3d()) {
+            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+            TextureRegistry.blockAtlas.bindTexture();
+            if (useColor) {
+                final int color = getColor(itemStack);
+                final float r = (color >> 16 & 0xff) / 255F;
+                final float g = (color >> 8 & 0xff) / 255F;
+                final float b = (color & 0xff) / 255F;
+                GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
+            } else {
+                GL11.glColor4f(brightness, brightness, brightness, alpha);
+            }
+            GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
+            BlockModel.renderBlocks.useInventoryTint = useColor;
+            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha);
+            BlockModel.renderBlocks.useInventoryTint = true;
+        } else {
+            super.renderItemInWorld(tessellator, entity, itemStack, brightness, alpha, worldTransform);
         }
+        GL11.glEnable(GL_CULL_FACE);
+        GL11.glDisable(GL_BLEND);
     }
     @Override
     public int getColor(ItemStack stack)
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
index 6d7481791..0d1ea90f2 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
@@ -31,8 +31,8 @@ public class ItemModelBow extends ItemModelStandard {
     }
 
     @Override
-    public void renderItem(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform) {
-        super.renderItem(tessellator, renderer, entity, itemstack, handheldTransform);
+    public void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, Entity entity, float brightness, boolean handheldTransform) {
+        super.renderItem(tessellator, renderer, itemstack, entity, brightness, handheldTransform);
         Item nextArrow = null;
         if (entity instanceof EntityPlayer){
             EntityPlayer entityplayer = (EntityPlayer)entity;
@@ -46,7 +46,7 @@ public class ItemModelBow extends ItemModelStandard {
         if (nextArrow != null){
             GL11.glRotatef(-90, 0, 0, 1);
             GL11.glTranslatef(-1,0, 0.0625f);
-            ItemModelDispatcher.getInstance().getDispatch(nextArrow).renderItem(tessellator, renderer, entity, itemstack, false);
+            ItemModelDispatcher.getInstance().getDispatch(nextArrow).renderItem(tessellator, renderer, itemstack, entity, brightness, false);
         }
     }
     @Override
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java
index 993ae6c53..3d454edaa 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelCoal.java
@@ -5,6 +5,8 @@ import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemModelCoal extends ItemModelStandard{
     protected IconCoordinate charcoal = TextureRegistry.getTexture("minecraft:item/charcoal");
@@ -13,7 +15,7 @@ public class ItemModelCoal extends ItemModelStandard{
     }
 
     @Override
-    public IconCoordinate getIcon(Entity entity, ItemStack itemStack)
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack)
     {
         if(itemStack.getMetadata() == 1)
             return charcoal;
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 7b8744ea4..95f4761cb 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -112,6 +112,8 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Item.foodAppleGold, "minecraft"));
         addDispatch(new ItemModelStandard(Item.sign, "minecraft"));
         addDispatch(new ItemModelStandard(Item.doorOak, "minecraft"));
+        addDispatch(new ItemModelStandard(Item.doorGlass, "minecraft"));
+        addDispatch(new ItemModelDoorPainted(Item.doorOakPainted));
         addDispatch(new ItemModelStandard(Item.bucket, "minecraft"));
         addDispatch(new ItemModelStandard(Item.bucketWater, "minecraft"));
         addDispatch(new ItemModelStandard(Item.bucketLava, "minecraft").setFullBright());
@@ -198,6 +200,8 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Item.seedsPumpkin, "minecraft"));
         addDispatch(new ItemModelStandard(Item.seat, "minecraft"));
 
+        addDispatch(new ItemModelStandard(Item.rope, "minecraft"));
+
         addDispatch(new ItemModelStandard(Item.record13, "minecraft"));
         addDispatch(new ItemModelStandard(Item.recordCat, "minecraft"));
         addDispatch(new ItemModelStandard(Item.recordBlocks, "minecraft"));
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java
new file mode 100644
index 000000000..7e0675f5a
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render.item.model;
+
+import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemDye;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.MathHelper;
+
+public class ItemModelDoorPainted extends ItemModelStandard{
+    public static IconCoordinate[] doorIcons = new IconCoordinate[16];
+    static {
+        for (int i = 0; i < 16; i++) {
+            doorIcons[i] = TextureRegistry.getTexture("minecraft:item/door_" + ItemDye.dyeColors[i]);
+        }
+    }
+    public ItemModelDoorPainted(Item item) {
+        super(item, null);
+    }
+    public IconCoordinate getIcon(Entity entity, ItemStack itemStack){
+        int meta = itemStack.getMetadata();
+        return doorIcons[MathHelper.clamp(meta, 0, 15)];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java
index 06872abbf..c11055ee5 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java
@@ -2,12 +2,13 @@ package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
-import net.minecraft.core.Global;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemDye;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemModelDye extends ItemModelStandard{
     public static IconCoordinate[] dyeIcons = new IconCoordinate[16];
@@ -20,7 +21,7 @@ public class ItemModelDye extends ItemModelStandard{
         super(item, null);
     }
 
-    public IconCoordinate getIcon(Entity entity, ItemStack itemStack){
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
         int meta = itemStack.getMetadata();
         return dyeIcons[MathHelper.clamp(meta, 0, 15)];
     }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java
index 3e5df793a..8a779de23 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java
@@ -6,6 +6,8 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemModelFishingRod extends ItemModelStandard {
     protected IconCoordinate rodCast = TextureRegistry.getTexture("minecraft:item/tool_fishingrod_cast");
@@ -14,10 +16,10 @@ public class ItemModelFishingRod extends ItemModelStandard {
     }
 
     @Override
-    public IconCoordinate getIcon(Entity entity, ItemStack itemStack){
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
         if (entity instanceof EntityPlayer){
             // Use the cast fishing rod texture when holding a cast rod
-            if(itemStack == ((EntityPlayer) entity).getHeldItem() && ((EntityPlayer) entity).fishEntity != null)
+            if(itemStack == ((EntityPlayer) entity).getHeldItem() && ((EntityPlayer) entity).bobberEntity != null)
             {
                 return rodCast;
             }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java
index 909e78695..6d0bfc378 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java
@@ -5,6 +5,8 @@ import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemModelLabel extends ItemModelStandard{
     protected IconCoordinate writtenLabel = TextureRegistry.getTexture("minecraft:item/label_written");
@@ -13,7 +15,7 @@ public class ItemModelLabel extends ItemModelStandard{
     }
 
     @Override
-    public IconCoordinate getIcon(Entity entity, ItemStack itemStack)
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack)
     {
         if(itemStack.hasCustomName()) {
             return writtenLabel;
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
index 658fa49cf..89406e5a9 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
@@ -2,14 +2,13 @@ package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.RenderEngine;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -24,7 +23,7 @@ public class ItemModelNone extends ItemModel{
     }
 
     @Override
-    public void renderItem(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform) {
+    public void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, @Nullable Entity entity, float brightness, boolean handheldTransform) {
 
     }
 
@@ -44,12 +43,17 @@ public class ItemModelNone extends ItemModel{
     }
 
     @Override
-    public void renderAsItemEntity(Tessellator tessellator, EntityItem entity, RenderBlocks renderBlocks, Random random, ItemStack itemstack, int renderCount, float yaw, float partialTick) {
+    public void renderAsItemEntity(Tessellator tessellator, @Nullable Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick) {
 
     }
 
     @Override
-    public IconCoordinate getIcon(Entity entity, ItemStack itemStack) {
+    public void renderItemInWorld(Tessellator tessellator, Entity entity, ItemStack itemStack, float brightness, float alpha, boolean worldTransform) {
+
+    }
+
+    @Override
+    public IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
         return null;
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java
index fdf0d5aab..6d0c2f662 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java
@@ -5,6 +5,8 @@ import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class ItemModelQuiver extends ItemModelStandard{
     protected IconCoordinate quiverFull = TextureRegistry.getTexture("minecraft:item/armor_quiver_full");
@@ -13,7 +15,7 @@ public class ItemModelQuiver extends ItemModelStandard{
     }
 
     @Override
-    public IconCoordinate getIcon(Entity entity, ItemStack itemStack)
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack)
     {
         if(itemStack.getMetadata() >= itemStack.getItem().getMaxDamage())
             return quiverFull;
